org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class OrderLocalStep<S,C extends Comparable>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.map.MapStep<S,E>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.map.ScalarMapStep<S,S>
      - - org.apache.tinkerpop.gremlin.process.traversal.step.map.OrderLocalStep<S,C>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<S>>, Step<S,S>, ByModulating, ComparatorHolder<S,C>, Seedable, TraversalParent

      public final class OrderLocalStep<S,C extends Comparable>
      extends ScalarMapStep<S,S>
      implements ComparatorHolder<S,C>, ByModulating, TraversalParent, Seedable

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `OrderLocalStep(Traversal.Admin traversal)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addComparator(Traversal.Admin<S,C> traversal, Comparator<C> comparator)` Add a `Traversal`-based `Comparator` to the holder.
    `OrderLocalStep<S,C>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `List<org.javatuples.Pair<Traversal.Admin<S,C>,Comparator<C>>>` | `getComparators()` Get the comparators associated with this holder.
    `List<Traversal.Admin<S,C>>` | `getLocalChildren()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `int` | `hashCode()`
    `protected S` | `map(Traverser.Admin<S> traverser)`
    `void` | `modulateBy(Traversal.Admin<?,?> traversal)`
    `void` | `modulateBy(Traversal.Admin<?,?> traversal, Comparator comparator)`
    `void` | `replaceLocalChild(Traversal.Admin<?,?> oldTraversal, Traversal.Admin<?,?> newTraversal)`
    `void` | `resetSeed(long seed)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.map.ScalarMapStep

      `processNextStart`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, hasStarts, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, reset, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.ByModulating

      `modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy, modulateBy`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getGlobalChildren, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### OrderLocalStep

          public OrderLocalStep(Traversal.Admin traversal)

  - ### Method Detail

    - #### resetSeed

          public void resetSeed(long seed)

      Specified by:
        `resetSeed` in interface `Seedable`

    - #### map

          protected S map(Traverser.Admin<S> traverser)

      Specified by:
        `map` in class `ScalarMapStep<S,S>`

    - #### addComparator

          public void addComparator(Traversal.Admin<S,C> traversal,
                                    Comparator<C> comparator)

      Description copied from interface: `ComparatorHolder`
      Add a `Traversal`-based `Comparator` to the holder. If no traversal is needed, use `IdentityTraversal`.
      Specified by:
        `addComparator` in interface `ComparatorHolder<S,C extends Comparable>`
      Parameters:
        `traversal` - the traversal to pre-process the object by.
        `comparator` - the comparator to compare the result of the object after traversal processing

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> traversal)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### modulateBy

          public void modulateBy(Traversal.Admin<?,?> traversal,
                                 Comparator comparator)

      Specified by:
        `modulateBy` in interface `ByModulating`

    - #### replaceLocalChild

          public void replaceLocalChild(Traversal.Admin<?,?> oldTraversal,
                                        Traversal.Admin<?,?> newTraversal)

      Specified by:
        `replaceLocalChild` in interface `TraversalParent`

    - #### getComparators

          public List<org.javatuples.Pair<Traversal.Admin<S,C>,Comparator<C>>> getComparators()

      Description copied from interface: `ComparatorHolder`
      Get the comparators associated with this holder. The comparators are ordered according to their oder of operation.
      Specified by:
        `getComparators` in interface `ComparatorHolder<S,C extends Comparable>`
      Returns:
        a list of `Traversal`/`Comparator`-pairs

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,S>`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,S>`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,S>`
      Returns:
        the set of requirements

    - #### getLocalChildren

          public List<Traversal.Admin<S,C>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### clone

          public OrderLocalStep<S,C> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,S>`
      Overrides:
        `clone` in class `AbstractStep<S,S>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,S>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,S>`
      Parameters:
        `parentTraversal` - the new traversal for this step

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.